unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, Menus, iCoolKey, ComCtrls, Gauges;

type
  TMainForm = class(TForm)
    BitBtn1: TBitBtn;
    Timer1: TTimer;
    Memo1: TMemo;
    TrackBar1: TTrackBar;
    Label1: TLabel;
    TrackBar2: TTrackBar;
    Label2: TLabel;
    Gauge1: TGauge;
    Label3: TLabel;
    Label4: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure BitBtn1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Timer1Timer(Sender: TObject);
    procedure BitBtn1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure TrackBar1Change(Sender: TObject);
    procedure TrackBar2Change(Sender: TObject);
    procedure Label3Click(Sender: TObject);
  private
    InMouseDown: Boolean;
    DesktopDC    : HDC;
    DesktopCanvas: TCanvas;
    CoolKeys: TCoolKeys;
    procedure Burst();
    procedure RegisterCoolKeys();
    procedure CancelBurst();
    procedure DispMode(const Mode: integer);
  protected
    procedure WndProc(var Msg: TMessage); override;
  public
    { Public 錾 }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

uses
    StrUtils;

const
    CR_SEEKER01 = 1;
    CR_SEEKER02 = 2;
const
    MODE_NONE     = 0;
    MODE_LOCKON   = 1;
    MODE_CANCELED = 2;
    MODE_LOST     = 3;
var
//    CUSTOM_CURSOR: Byte = CR_SEEKER01;
    CUSTOM_CURSOR: Byte = CR_SEEKER02;
var
    TargetHandle: HWND = INVALID_HANDLE_VALUE;
    TargetParent: HWND = INVALID_HANDLE_VALUE;
    BurstCount: integer = 0;
    BurstSleep: integer = 0;
const
    HOOK_DLL_NAME  = 'hook.dll';
const
    //  ʒmpEBhEbZ[W(DLL to EXE)
    UM_DESTROYWND  = WM_APP + 1001; //  CBTProc(in DLL)
    UM_LMOUSEUP    = WM_APP + 1002; //  MouseProc(in DLL)
    UM_RMOUSEUP    = WM_APP + 1003; //  MouseProc(in DLL)

//  ===========================================================================
//  DLLC|[gEăX^eBbNN
function    HookInstall(Wnd: HWND): Boolean; stdcall;external HOOK_DLL_NAME;
procedure   HookUnInstall(); stdcall;external HOOK_DLL_NAME;
procedure   HookInitialize(); stdcall;external HOOK_DLL_NAME;
procedure   HookFinalize(); stdcall;external HOOK_DLL_NAME;

//  ===========================================================================
//  Win32 API by Object Pascal of Delphi
//  ---------------------------------------------------------------------------
//  http://homepage2.nifty.com/Mr_XRAY/Halbow/VCL06.html#VChap6-7
function GetClassNameStr(hWindow:HWND):string;
var
  p:PChar;
  ret:integer;
begin
  GetMem(p,100);
  ret := GetClassName(hWindow,p,100);
  SetString(result,p,ret);
  FreeMem(p);
end;
//  ===========================================================================
function GetWindowTextStr(hWindow:HWND):string;
var
  p:PChar;
  ret:integer;
begin
  ret := GetWindowTextLength(hWindow);
  GetMem(p,ret+1);
  ret := GetWindowText(hWindow,p,ret+1);
  SetString(result,p,ret);
  FreeMem(p);
end;
//  ===========================================================================
function GetMostTopLevelWindow(hWindow:HWND):HWND;
var
  hAncestor,hPrev:HWND;
begin
  hPrev := hWindow;
  hAncestor := GetParent(hPrev);
  while hAncestor <> 0  do begin
    hPrev := hAncestor;
    hAncestor := GetParent(hPrev)
  end;
  hAncestor := hPrev;
  while hAncestor <> 0  do begin
    hPrev := hAncestor;
    hAncestor := GetWindow(hPrev,GW_OWNER)
  end;
  result := hPrev;
end;


//  ===========================================================================
//  zbgL[o^
procedure TMainForm.DispMode(const Mode: integer);
var
    s: string;
begin
    case Mode of
    MODE_LOCKON:
        begin
            s := 'LOCKED ON';
        end;
    MODE_CANCELED:
        begin
            s := 'CANCELED';
        end;
    MODE_LOST:
        begin
            s := 'TARGET LOST';
        end;
    else
        begin
            s := '';
        end;
    end;
    Label3.Caption := s;
end;

//  ===========================================================================
//  zbgL[o^
procedure TMainForm.RegisterCoolKeys();
begin
    CoolKeys.Clear;
    CoolKeys.Add(CancelBurst, [ssShift], VK_ESCAPE);
end;

//  ===========================================================================
//  RXgN^
//  ---------------------------------------------------------------------------
//  http://www.borland.co.jp/tips/delphi/dh008/
//  http://forum.nifty.com/fdelphi/faq/00289.htm
procedure TMainForm.FormCreate(Sender: TObject);
var
    Dir: string;
begin
    DispMode(MODE_NONE);

    GetDir(0, Dir);
    //  J[\Ǎ
    Screen.Cursors[CR_SEEKER01] := LoadCursorFromFile(PChar(Dir + '\rsc\seek01.cur'));
    Screen.Cursors[CR_SEEKER02] := LoadCursorFromFile(PChar(Dir + '\rsc\seek02.cur'));

    //  Lv`łȂ
    InMouseDown := false;

    //  o[Xg
    TrackBar1.Position := 2;
    TrackBar2.Position := 5;

    //  fXNgbṽfoCXReLXg
    DesktopDC := GetDC(0);
    DesktopCanvas := TCanvas.Create;
    DesktopCanvas.Handle := DesktopDC;
    DesktopCanvas.Pen.Width := 3;
    DesktopCanvas.Pen.Mode := pmNotXor;

    //  zbgL[o^
    CoolKeys := TCoolKeys.Create();
    RegisterCoolKeys();

    //  tbN
    HookInitialize();
    //  tbNCXg[
    HookInstall(Self.Handle);
end;

//  ===========================================================================
//  fXgN^
procedure TMainForm.FormDestroy(Sender: TObject);
begin
    //  tbNACXg[
    HookUnInstall();
    //  tbNn
    HookFinalize();
    //  zbgL[
    CoolKeys.Free;
    //  fXNgbṽfoCXReLXgj
    DesktopCanvas.Free;
    ReleaseDC(0, DesktopDC);
end;

//  ===========================================================================
//  ^[QbgEBhE擾̗Jn
procedure TMainForm.BitBtn1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
    InMouseDown := true;
    CancelBurst();
    DispMode(MODE_NONE);
    Screen.Cursor := CUSTOM_CURSOR;
end;

//  ===========================================================================
//  łHłH
procedure TMainForm.Timer1Timer(Sender: TObject);
var
    WH, WH2: HWND;
//    DC: HDC;
    RT: TRect;
    WI: TWindowInfo;
    s: string;
begin
    //  ҋ@
    if (not InMouseDown) then
    begin
        //  Ƀ^[Qbg
        if (TargetHandle <> INVALID_HANDLE_VALUE) then
        begin
            //  ݃`FbN
            if not GetWindowInfo(TargetHandle, WI) then
            begin
                CancelBurst();
                DispMode(MODE_LOST);
            end;
        end;
    end
    //  XpC
    else
    begin
        //  ?
        if (GetAsyncKeyState(VK_ESCAPE) <> 0) then
        begin
            InMouseDown := false;
            Screen.Cursor := crDefault;
            Exit;
        end;
        //  }EẌʒũEBhEnh擾
        WH := WindowFromPoint(Mouse.CursorPos);
        //  ̃EBhẼgbvx̐ẽnh擾
        WH2 := GetMostTopLevelWindow(WH);
        //  Ȃ낤˂
        if (WH2 = GetMostTopLevelWindow(Self.Handle)) then Exit;
        //  ̃NXƂ肾肵ĕ\
        s := Format(' %d:%s(%s)', [WH, GetClassNameStr(WH), GetWindowTextStr(WH)]);
        //  ̃NXƂ肾肵ĕ\
        s := Format('%d:%s(%s)'#13#10'%s', [WH2, GetClassNameStr(WH2), GetWindowTextStr(WH2), s]);
        Memo1.Text := s;
        //  EBhE擾
        GetWindowInfo(WH, WI);
        //  NCAg̈擾
        RT := WI.rcWindow;
        //  fXNgbvɋ``(XOR)
        DesktopCanvas.Rectangle(RT);
        //  ΂҂
        Sleep(100);
        //  fXNgbvɋ``(XOR)
        DesktopCanvas.Rectangle(RT);
    end;
end;

//  ===========================================================================
//  ^[QbgEBhE擾̗I
//  ---------------------------------------------------------------------------
//  http://forum.nifty.com/fdelphi/samples/00495.html
procedure TMainForm.BitBtn1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
    //  XpCłȂ΃XLbv
    if InMouseDown then
    begin
        //  tO|ăJ[\ɖ߂
        InMouseDown := false;
        Screen.Cursor := crDefault;
        //  }EX̃EBhEnho
        TargetHandle := WindowFromPoint(Mouse.CursorPos);
        TargetParent := GetMostTopLevelWindow(TargetHandle);
        //  Ȃ낤˂
        if (TargetParent = GetMostTopLevelWindow(Self.Handle)) then
        begin
            CancelBurst();
            DispMode(MODE_NONE);
            Exit;
        end;
        //  ێ
        Memo1.Clear;
        Memo1.Lines.Add(Format('Target Handle = %d', [TargetHandle]));
        Memo1.Lines.Add(Format('Target Parent = %d', [TargetParent]));

        DispMode(MODE_LOCKON);
    end;
end;

var
    BurstLock: Boolean = false;

//  ===========================================================================
//  bNI
procedure TMainForm.CancelBurst();
begin
    TargetHandle := INVALID_HANDLE_VALUE;
    TargetParent := INVALID_HANDLE_VALUE;
    Memo1.Clear;
    DispMode(MODE_NONE);
    BurstLock := false;
end;

//  ===========================================================================
//  1 SNbN
procedure	TMainForm.Burst;
var
    i: integer;
    Pos: TPoint;
    RT: TRect;
    WI: TWindowInfo;
begin
    if BurstLock then exit;
    BurstLock := true;
    if TargetHandle <> INVALID_HANDLE_VALUE then
    begin
        Gauge1.MaxValue := BurstCount;
        Gauge1.Progress := 1;
        for i := 1 to BurstCount do
        begin
            //  LZ`FbN
            if (TargetHandle = INVALID_HANDLE_VALUE) then break;
            //  J[\̈ʒu擾
            GetCursorPos(Pos);
            //  ^[QbgEBhE擾(snhƂ݂Ȃ)
            if not GetWindowInfo(TargetHandle, WI) then
            begin
                CancelBurst();
                DispMode(MODE_LOST);
                break;
            end
            else
            begin
                //  NCAg̈擾
                RT := WI.rcWindow;
//                RT := WI.rcClient;
                //  
                if PtInRect(RT, Pos) then
                begin
                    //  NbNʒu^[QbgWɕϊ
                    Pos.X := Pos.X - RT.Left;
                    Pos.Y := Pos.Y - RT.Top;
                    //  {^E
                    SendMessage(TargetHandle, WM_LButtonDown, 0, MakeLong(Pos.X, Pos.Y));
                    SendMessage(TargetHandle, WM_LButtonUp, 0, MakeLong(Pos.X, Pos.Y));
                end;
                //  ҂
                Sleep(BurstSleep);
                //  
                Gauge1.Progress := Gauge1.Progress + 1;
            end;
        end;
    end;
    BurstLock := false;
end;

//  ===========================================================================
//  EBhEvV[W
procedure TMainForm.WndProc(var Msg: TMessage);
var
    WParamHW: HWND; 
begin
    //  LXg
    WParamHW := HWND(Msg.WParam);

    case Msg.Msg of
    //  EBhEj
    UM_DESTROYWND:
        begin
            if (WParamHW = TargetParent) then
            begin
                CancelBurst();
                DispMode(MODE_LOST);
            end;
        end;

    //  {^グ
    UM_LMOUSEUP:
        begin
            if (WParamHW = TargetHandle) then
            begin
                Burst;
            end;
        end;

    //  E{^グ
    UM_RMOUSEUP:
        begin
            if (WParamHW = TargetHandle) then
            begin
                Memo1.Lines.Add('E{^グ܂');
            end;
        end;
    end;

    inherited;
end;

//  ===========================================================================
//  o[Xg
procedure TMainForm.TrackBar1Change(Sender: TObject);
begin
    BurstCount := TrackBar1.Position;
    Label1.Caption := Format('+ %d Click!', [BurstCount]);
end;

//  ===========================================================================
//  o[XgC^[o
procedure TMainForm.TrackBar2Change(Sender: TObject);
begin
    BurstSleep := TrackBar2.Position;
    Label2.Caption := Format('%d ms sleep', [BurstSleep]);
end;

//  ===========================================================================
//  ǂH
procedure TMainForm.Label3Click(Sender: TObject);
var
    WI: TWindowInfo;
    RT: TRect;
begin
    if (TargetParent <> INVALID_HANDLE_VALUE) then
    begin
        SetForegroundWindow(TargetParent);

        //  ΂҂
        Sleep(100);

        //  EBhE擾
        if not GetWindowInfo(TargetHandle, WI) then
        begin
            CancelBurst();
            DispMode(MODE_NONE);
        end
        else
        begin
            //  NCAg̈擾
            RT := WI.rcWindow;
            //  fXNgbvɋ``(XOR)
            DesktopCanvas.Rectangle(RT);
            //  ΂҂
            Sleep(200);
            //  fXNgbvɋ``(XOR)
            DesktopCanvas.Rectangle(RT);
            //  ΂҂
            Sleep(200);
        end;

        Application.BringToFront();
    end;
end;

end.

